PUB GearTest

        cognew( @entry, 0 )

CON
        Zeq0 = 0
        Zeq1 = 1
        Ceq0 = 0
        Ceq1 = 1
DAT

              ORG       0
entry

        '======= Subroutine TI (Test Instruction) executes SUBX with the
        '======= given values for dest, source, Z flag and C flag.
        '======= destExp is the expected result of the instruction and
        '======= Zexp and Cexp are the expected Z and C flags after execution
        '======= The routine returns a bit mapped result after execution...
        '=======   if dest   does not equal destExp, %100 is set.
        '=======   if Z flag does not equal Zexp,    %010 is set
        '=======   if C flag does not equal Cexp,    %001 is set

''      declareSub TI( dest, source, Zin, Cin, destExp, Zexp, Cexp)

''      array ans[6]

''      symbolicConstants Zeq0  Zeq1  Ceq0  Ceq1

''      ans[0] = beginAnsTag    ' Visually mark beginning of ans array
              mov       ans+0, beginAnsTag

''      ans[1] = TI( con001, con001, Zeq0, Ceq0, con000, Zeq0, Ceq0)
              mov       TI_dest, con001
              mov       TI_source, con001
              mov       TI_Zin, #Zeq0
              mov       TI_Cin, #Ceq0
              mov       TI_destExp, con000
              mov       TI_Zexp, #Zeq0
              mov       TI_Cexp, #Ceq0
              call      #TI
              mov       ans+1, TI_result

''      ans[2] = TI( con001, con001, Zeq1, Ceq0, con000, Zeq1, Ceq0)
              mov       TI_dest, con001
              mov       TI_source, con001
              mov       TI_Zin, #Zeq1
              mov       TI_Cin, #Ceq0
              mov       TI_destExp, con000
              mov       TI_Zexp, #Zeq1
              mov       TI_Cexp, #Ceq0
              call      #TI
              mov       ans+2, TI_result

''      ans[3] = TI( con001, con001, Zeq0, Ceq1, conFFF, Zeq0, Ceq1)
              mov       TI_dest, con001
              mov       TI_source, con001
              mov       TI_Zin, #Zeq0
              mov       TI_Cin, #Ceq1
              mov       TI_destExp, conFFF
              mov       TI_Zexp, #Zeq0
              mov       TI_Cexp, #Ceq1
              call      #TI
              mov       ans+3, TI_result

''      ans[4] = TI( con001, con001, Zeq1, Ceq1, conFFF, Zeq0, Ceq1)
              mov       TI_dest, con001
              mov       TI_source, con001
              mov       TI_Zin, #Zeq1
              mov       TI_Cin, #Ceq1
              mov       TI_destExp, conFFF
              mov       TI_Zexp, #Zeq0
              mov       TI_Cexp, #Ceq1
              call      #TI
              mov       ans+4, TI_result

''      ans[5] = endAnsTag      ' Visually mark end of ans array
              mov       ans+5, endAnsTag

''      loop
aac1
''      endLoop
              jmp       #aac1
aac2


'' beginsub TI {dest, source, Zin, Cin, destExp, Zexp, Cexp } 
TI
''            
''            sub       TI_Zin,#1            wz,nr  ' Set Z flag = Zin
              sub       TI_Zin, #1              wz,nr
''            add       conFFF,TI_Cin        wc,nr  ' Set C flag = Cin
              add       conFFF, TI_Cin          wc,nr
''
''            {Execute the instruction under test and write Z and C flags}

''            subx      TI_dest, TI_source   wz,wc
              subx      TI_dest, TI_source      wz,wc
''            
''      if_z  sub  TI_Zexp,#1  
        if_z  sub       TI_Zexp, #1
''      if_c  sub  TI_Cexp,#1
        if_c  sub       TI_Cexp, #1
''
''            TI_result = 0
              mov       TI_result, #0
''
''            if TI_Zexp <> 0           {Check for expected Z}
              cmp       TI_Zexp, #0             wc,wz
        if_e  jmp       #aac3
''              TI_result |= %010
              or        TI_result, #%010
''            endif
aac3
aac4
''
''            if TI_Cexp <> 0           {Check for expected C}
              cmp       TI_Cexp, #0             wc,wz
        if_e  jmp       #aac5
''              TI_result |= %001
              or        TI_result, #%001
''            endif
aac5
aac6
''
''            if TI_dest <> TI_destExp
              cmp       TI_dest, TI_destExp     wc,wz
        if_e  jmp       #aac7
''              TI_result |= %100
              or        TI_result, #%100
''            endif
aac7
aac8
''             
'' endSub   TI
TI_ret        ret

beginAnsTag   long      $AAAAAAAA
endAnsTag     long      $BBBBBBBB


con000  long  $00000000
con001  long  $00000001
con002  long  $00000002
con7FF  long  $7FFFFFFF ' Largest positive number
con7FE  long  $7FFFFFFE ' Next largest positive number
con800  long  $80000000 ' Largest negative number
con801  long  $80000001 ' Next largest negative number
conFFF  long  $FFFFFFFF ' -1
conFFE  long  $FFFFFFFE ' -2

''            finishCodeSection
'
' Auto generated subroutine parameters.....
'
TI_result                 res       1
TI_dest                   res       1
TI_source                 res       1
TI_Zin                    res       1
TI_Cin                    res       1
TI_destExp                res       1
TI_Zexp                   res       1
TI_Cexp                   res       1
'
' Auto generated array allocation.....
'
ans                       res       6  {size is from array declaration}

              fit       496






